--Function FFT(a,inv) computes a Fast Fourier Transform of a, if inv = 1
--if inv = -1 then it computes the inverse Transform
--please note that this is not the fast fourier cosine transform used in the
--decompression of Jpeg images...
--Written by Laurence Draper
--Comments, questions? E-mail me vonfreudenhowser@rhodale.co.uk

include machine.e
include complex.e


function log2(atom n)
    return log(n)/log(2)
end function

function bits(atom len)
    sequence ret
    atom temp1
    temp1 = 0
    ret = repeat(0,power(2,len))
    for t = 1 to length(ret)  do
        ret[t] = temp1
        temp1+=1
    end for
    temp1 = len
    for t = 1 to length(ret) do
        ret[t] = int_to_bits(ret[t],temp1)
    end for
    return ret
end function

function rev(sequence a)
sequence ret
ret = repeat(0,length(a))
    for t = length(a) to 1 by -1 do
        ret[length(a)-t+1] = a[t]
    end for
    return ret
end function

function BitReverse(sequence a,atom len)
    sequence ret,temp1
    Img Num
    Num = {0,0}
    temp1 = repeat(0,power(2,len))
    ret = temp1
    temp1 = bits(len)

    for t = 1 to length(temp1) do
        temp1[t] = rev(temp1[t])
    end for

    for t = 1 to length(temp1) do
        temp1[t] = bits_to_int(temp1[t])
    end for
    for t = 1 to length(temp1)  do
        ret[temp1[t]+1] = a[t]
    end for
    return ret
end function

function makelength(sequence a,atom len)
    atom temp
    temp = len-length(a)
    for t = 1 to temp do
        a = prepend(a,{0,0})
    end for
    return a
end function

function round(sequence a,atom level)
    atom temp
    for t = 1 to length(a) do
        for y = 1 to 2 do
	    temp = floor(a[t][y]/level)
	    if a[t][y]/level - temp > 0.5 then
		temp = temp + 1
	    end if
        temp = temp*level
        a[t][y] = temp
        end for
    end for
    return a
end function


global function FFT(sequence a,atom inv)
    sequence A,W
    atom n,m,temp
    Img Num,w,u,t

    Num = {0,0}
    n = length(a)
    A = {}
    temp = log2(n)

    if not integer(temp) then
        temp = floor(temp)+1
        a = makelength(a,power(2,temp))
    end if

    n = length(a)
    W = repeat(Num,n)
    A = BitReverse(a,temp)

    for s = 1 to temp do
        m = power(2,s)
        W[m] = EI({0,2*pi/m*inv})
        w = {1,0}
        for j = 0 to (m/2)-1 do
	    for k = j to n-1 by m do
		t = Img_mult(w,A[k+m/2+1])
		u = A[k+1]
		A[k+1] = Img_add(u,t)
		A[k+m/2+1] = Img_sub(u,t)
	    end for
	    w = Img_mult(w,W[m])
        end for
    end for

    if inv = -1 then
        for tw = 1 to length(A) do
	    A[tw][1] = A[tw][1]/n
	    A[tw][2] = A[tw][2]/n
        end for
    end if

    return A
end function

