include machine.e
include bignum1.e

bignum bits
atom k
atom s,err
s = 9
err = power(2,-s)
function rev(sequence a)
    sequence ret
    ret = repeat(0,length(a))
    for t = 1 to length(a) do
        ret[length(a)+1-t] = a[t]
    end for
    return ret
end function

function sec(sequence inp)
    return inp[2]
end function

function Witness(bignum a, bignum n)
    bignum x
    sequence d
    d = {1}
    for i = k to 1 by -1 do
        x = d
        d = bn_mult(d,d)
        d = sec(bn_div(d,n))
--        d = d[2]
        if d[1] = 1 and not x[1] = 1 and not bn_compare(x,bn_dec(n)) = 0 then
	    return 1
        end if
        if bits[i] = 1 then
	    d = bn_div(bn_mult(d,a),n)
	    d = d[2]
        end if
    end for
    if not bn_compare(d,{1}) = 0 then
        return 1
    end if
    return 0
end function

global function IsPrime(bignum n) --Miller - Rabin method
    bignum a
    if n[length(n)] = 5 or integer(n[length(n)]/2) then
        return 0
    end if
    bits = bn_baseconv(bn_dec(n),10,2)
    bits = rev(bits)
    k = length(bits)
    for j = 1 to s do
        a = bn_rand(bn_dec(n))
        if Witness(a,n) = 1 then
	    return 0
        end if
    end for
    return 1
end function

global function find_prime(atom x) --find a prime no with at least n digits
    bignum n
    n = repeat(0,x)
    for t = 1 to x do
        n[t] = rand(9)
    end for
    if integer(n[length(n)]/2) then
        n = bn_inc(n)
    end if
    while 1 do
        if IsPrime(n) = 1 then
	    exit
        end if
        n = bn_inc(n)
        n = bn_inc(n)
    end while
    return n
end function



