include get.e
include constant.e

atom dx,dy,ordinates,integral,interval,rho,QUIT,val,time1
sequence limits,spec
object temp

limits = {0,0,0,0,0}
spec = {0,1,0,1}
QUIT = 0
ordinates = 80
integral = 0
rho = 0

function StandBiVariateVal(atom x, atom y)
    return e_ (-(x*x-2*rho*x*y+y*y)/(2-2*rho*rho))
end function

function ToNum(sequence temp)

    atom res,ten,minus,decimal,dec
    sequence me

    minus = 1
    me = {}
    temp = temp[1..length(temp)-1]
    res = 0
    decimal = 0
    dec = 0

    if temp[1] = '-' then
        minus = -1
        temp = temp[2..length(temp)]
    end if

    for tem = 1 to length(temp) do

        if temp[tem]  = 46 then
	    decimal = tem-1
        end if

    end for
    if decimal > 0 then
        me = temp[1..decimal]
        temp = me & temp[decimal+2..length(temp)]
        dec = length(temp)-decimal
    end if

    ten = length(temp)-1

    for t = 1 to length(temp) do

        res += (temp[t]-48)*power(10,ten)
        ten -= 1

    end for

    res = res/(power(10,dec))

    return res*minus
end function

function GenBiVariateInt(sequence limits)
    atom ax,bx,ay,By,mux,muy,sigmax,sigmay,z1,a,b,c

    interval = 0.03
    mux = limits[1]
    muy = limits[3]
    sigmax = limits[2]
    sigmay = limits[4]
    ax = limits[6]
    bx = limits[5]
    ay = limits[8]
    By = limits[7]
    integral = 0

    if (bx-ax) > (By-ay) then
        ordinates = floor((bx-ax)/interval)
    else
        ordinates = floor((By-ay)/interval)
    end if

    if ordinates < 50 then
        ordinates = 50
    end if
    if ordinates > 200 then
        ordinates = 200
    end if
    dy = (By-ay)/(ordinates*sigmay)
    dx = (bx-ax)/(ordinates*sigmax)

    a = (ax-mux)/sigmax
    b = (bx-mux)/sigmax
    c = (ay-muy)/sigmay
    z1 = a

    integral += StandBiVariateVal(a,c)/2
    integral += StandBiVariateVal(b,c)/2

    for ty = 0 to ordinates-1 do

        for tx = 1 to ordinates-1 do


	    z1 += dx

	    integral += StandBiVariateVal(z1,c)
	    integral += StandBiVariateVal(z1,c+dy)

        end for

        c += dy
        integral += StandBiVariateVal(b,c)
        z1 = a
        integral += StandBiVariateVal(a,c)

    end for

    integral += StandBiVariateVal(a,c+dy)/2
    integral += StandBiVariateVal(b,c+dy)/2

    integral *= (dx*dy)/(4*pi*sqrt(1-rho*rho))

    return integral
end function

function GenNormalInt(sequence limits)
    atom ax,bx,mux,sigmax,z1

    interval = 0.001
    mux = limits[1]
    sigmax = limits[2]
    ax = limits[4]
    bx = limits[3]
    integral = 0
    ordinates = floor((bx-ax)/interval)

    if ordinates < 30 then
        ordinates = 30
    end if

    dx = (bx-ax)/(ordinates)
    z1 = (ax-mux)/sigmax
    integral += e_ (-z1*z1/2)/2
    integral += e_ (-(bx-dx)*(bx-dx)/2)/2
    dx /= sigmax

    for tx = 1 to ordinates-1 do

        z1 += dx
        integral += e_ (-z1*z1/2)

    end for

    integral *= dx/sqrt(2*pi)
    return integral
end function

function GetXLimits()
    sequence limits
    limits = {0,0}
    puts(1,"Enter Max X val ")
    temp = gets(0)
    puts(1,"\n")
    limits[1] = ToNum(temp)
    puts(1,"Enter Min X val ")
    temp = gets(0)
    puts(1,"\n")
    limits[2] = ToNum(temp)
    return limits
end function

function GetYLimits()
    sequence limits
    limits = {0,0,0}
    puts(1,"Enter Max Y val ")
    temp = gets(0)
    puts(1,"\n")
    limits[1] = ToNum(temp)
    puts(1,"Enter Min Y val ")
    temp = gets(0)
    puts(1,"\n")
    limits[2] = ToNum(temp)
    puts(1,"Enter rho val ")
    temp = gets(0)
    puts(1,"\n")
    rho = ToNum(temp)
    return limits
end function

function GetXSpec()
    sequence limits
    limits = {0,0}
    puts(1,"Enter Mu X val ")
    temp = gets(0)
    puts(1,"\n")
    limits[1] = ToNum(temp)
    puts(1,"Enter Sigma X val ")
    temp = gets(0)
    puts(1,"\n")
    limits[2] = ToNum(temp)
    return limits
end function

function GetYSpec()
    sequence limits
    limits = {0,0}
    puts(1,"Enter Mu Y val ")
    temp = gets(0)
    puts(1,"\n")
    limits[1] = ToNum(temp)
    puts(1,"Enter Sigma Y val ")
    temp = gets(0)
    puts(1,"\n")
    limits[2] = ToNum(temp)
    return limits
end function

while QUIT = 0 do
    puts(1,"(u)ni- or (b)i- variate data?")
    temp = wait_key()
    puts(1,"\n")
    if temp = 'u' then
        puts(1,"(s)tandard or s(p)ecific data?")
        temp = wait_key()
        puts(1,"\n")

        if temp = 's' or temp = 'p' then
	    if temp = 's' then
		spec = {0,1}
	    elsif temp = 'p' then
		spec = GetXSpec()
	    end if

        limits = GetXLimits()
        time1 = time()
        val = GenNormalInt(spec&limits)
        time1 = time()-time1
        else
	    puts(1,"what?????")
	    puts(1,"\n")
	    val = -1
	    time1 = -1
        end if

    elsif temp = 'b' then
        puts(1,"(s)tandard or s(p)ecific data?")
        temp = wait_key()
        puts(1,"\n")

        if  temp = 'p' or temp = 's' then
	    if temp = 'p' then
		spec = GetXSpec()&GetYSpec()
	    end if

        limits = GetXLimits()&GetYLimits()
        time1 = time()
        val = GenBiVariateInt(spec&limits)
        time1 = time()-time1
        else
	    puts(1,"what?????")
	    puts(1,"\n")
	    val = -1
	    time1 = -1
        end if
    else
        puts(1,"what?????")
        puts(1,"\n")
        val = -1
        time1 = -1
    end if
    printf(1,"\n%1.6g\nin %1.5g seconds\n", {val,time1})
    puts(1,"Another?")
    temp = wait_key()
    if temp != 'y' then
        QUIT = 1
    end if
    puts(1,"\n")
    integral = 0
    limits = {}
    spec = {0,1,0,1}
end while


